package com.fuyuanshen.app.mapper;

import com.fuyuanshen.app.domain.AppRole;
import com.fuyuanshen.app.domain.vo.AppRoleVo;
import com.fuyuanshen.common.mybatis.annotation.DataColumn;
import com.fuyuanshen.common.mybatis.annotation.DataPermission;
import com.fuyuanshen.common.mybatis.core.mapper.BaseMapperPlus;

import java.util.List;

/**
 * 角色信息Mapper接口
 *
 * @author Lion Li
 * @date 2025-06-27
 */
public interface AppRoleMapper extends BaseMapperPlus<AppRole, AppRoleVo> {


    /**
     * 根据用户ID查询角色
     *
     * @param userId 用户ID
     * @return 角色列表
     */
    List<AppRoleVo> selectRolesByUserId(Long userId);

}
